package me.ChrisvA.MinecartExtra;


import java.util.HashMap;
import java.util.List;
import java.util.UUID;
import java.util.logging.Logger;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Item;
import org.bukkit.entity.Player;
import org.bukkit.entity.StorageMinecart;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.java.JavaPlugin;

public class MinecartExtra extends JavaPlugin {
  
	private Logger log = Logger.getLogger("Minecraft");
	
	private MinecartExtraVehicleListener vehicleListener; 
	
	private HashMap<UUID, MinecartCollector> collectionMinecarts;
	
	//            PlayerId, Cleanups
	private HashMap<UUID, Integer> playersCollectCreate;
	
	private Boolean clean = false;
	
	private MinecartExtraConfig config;
	private MinecartExtraPermissions perm;
	private MinecartExtraString plstr;
	
	public final String cmdCollect = "collect";
	
	public void onEnable(){ 
		
        log.info("Minecart Extra wird geladen.");
        //permissions = new Permission();
        collectionMinecarts = new HashMap<UUID, MinecartCollector> ();
        playersCollectCreate = new HashMap<UUID, Integer> ();
        
        vehicleListener = new MinecartExtraVehicleListener(this);
        
        config = new MinecartExtraConfig(this);
        perm = new MinecartExtraPermissions(this);
        
        getServer().getPluginManager().registerEvents(vehicleListener, this);
        plstr = new MinecartExtraString();
        //tickszaehler aktivieren
        
        getServer().getScheduler().scheduleAsyncRepeatingTask(this, new Runnable() {

            public void run() {
                cleanup();
            }
        }, config.getCollectCleanup(), config.getCollectCleanup());
        
    }
	
    public void onDisable(){ 
    }

    public void StorageMinecartMove (StorageMinecart cart){
    	if (clean == true){
    		//Prevent that 
    		//getServer().broadcastMessage(ChatColor.AQUA + "Move verworfen");
    		return;
    	}
		if (collectionMinecarts.containsKey(cart.getUniqueId())){
			if (collectionMinecarts.get(cart.getUniqueId()).CollectionTime()){
				//Collect items
				
				List<Entity> near = cart.getNearbyEntities(config.getCollectHradius(), 
						config.getCollectVradius(), config.getCollectHradius());
				
				//getServer().broadcastMessage("Collect" + near.size());
				for (Entity e: near){
					
					if (e instanceof Item){
						Item i = (Item) e;
						if(!i.isDead()){
							//Item Einpacken und entfernen
							HashMap<Integer, ItemStack> rest = cart.getInventory().addItem(i.getItemStack());
							//getServer().broadcastMessage(ChatColor.AQUA + "NichtVerwendbar" + rest.size());
							if(rest.size() == 0){
								i.remove();
							}else{
								for ( int key : rest.keySet() ){
									i.getItemStack().setAmount(rest.get(key).getAmount());
								}
							}
							
						}
					}
				}
			}
		}else if(config.isCollectAutodetect()){
			collectionMinecarts.put(cart.getUniqueId(), 
					new MinecartCollector(cart.getLocation().getWorld(), config.getCollectRate()));
			
			//getServer().broadcastMessage("Insert" + collectionMinecarts.size());
		}
    }
    
    
    
    /*public void Dummy(){
    	getServer().broadcastMessage(ChatColor.AQUA + "Dummy");
    }*/
    
    private void cleanup(){
    	clean = true;
    	//getServer().broadcastMessage(ChatColor.AQUA + "cleanup");
    	for (UUID key : collectionMinecarts.keySet()){
    		if ( !collectionMinecarts.get(key).isPlayerCart()){
    			if((collectionMinecarts.get(key).getNoMoveTime()) > config.getCollectCleanup()){
	    			//The Cart doesn't move since last cleanup
	    			//getServer().broadcastMessage(ChatColor.AQUA + "remove");
	    			collectionMinecarts.remove(key);
	    		}
    		}else{
    			// Check if time is out for Minecarts added by a Player
    			if((collectionMinecarts.get(key).getLifeTime()) > 
    			(config.getCollectCleanup() * config.getCollectTimeCollection()) ){
	    			//The Cart doesn't move since last cleanup
	    			//getServer().broadcastMessage(ChatColor.AQUA + "Premove");
	    			collectionMinecarts.remove(key);
	    		}
    		}
    	}
    	
    	for (UUID id : playersCollectCreate.keySet()){
    		if (playersCollectCreate.get(id) >= config.getCollectTimeplayers() ){
    			playersCollectCreate.remove(id);
    		}else{
    			Integer num = playersCollectCreate.get(id);
    			++num;
    			playersCollectCreate.put(id, num);
    		}
    	}
    	
    	clean = false;
    }
    
    public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args){
    	if(cmd.getName().equalsIgnoreCase(cmdCollect)){
    		
    		if (args.length == 0){
    			return false;
    		}
    		if (!(sender instanceof Player)){
    			//By Console or RemoteConsole
    			if (args[0].equalsIgnoreCase("info")){
    				sendInfo (sender);
    				return true;
    			}
    		}else{
    			//By Player
    			Player p = (Player) sender;
    			if (args[0].equalsIgnoreCase("info")){
    				
    				if (perm.hasInfo(p)){
    					sendInfo (sender);
        			}else{
        				sendNoPermissions(p);
        			}
    				return true;
    			}else if(args[0].equalsIgnoreCase("create")){
    				if (perm.hasCreateAutostrage(p)){
   						playersCollectCreate.put(p.getUniqueId(), 0);
   						p.sendMessage(ChatColor.YELLOW + plstr.getLeftKlickAMinecart());
    				}else{
    					sendNoPermissions(p);
    				}
    				return true;
    			}
    		}
    		
    		return true;
    	} //If this has happened the function will break and return true. if this hasn't happened the a value of false will be returned.
    	return false; 
    }


    private void sendNoPermissions(Player p) {
		p.sendMessage(ChatColor.RED + plstr.getNoPermissions());
	}

	private void sendInfo (CommandSender sender){
    	sender.sendMessage(getDescription().getFullName());
    	sender.sendMessage(plstr.getCollectMinecarts() + ": " + collectionMinecarts.size());
    	sender.sendMessage("hradius: " + config.getCollectHradius());
    	sender.sendMessage("vradius: " + config.getCollectVradius());
    	sender.sendMessage("rate: " + config.getCollectRate());
    	sender.sendMessage("cleanup: " + config.getCollectCleanup());
    	sender.sendMessage("timplayers: " + config.getCollectTimeplayers());
    	sender.sendMessage("timecollection: " + config.getCollectTimeCollection());
    	sender.sendMessage("autodetect: " + config.isCollectAutodetect());
    }

	 public boolean StorageMinecartDamage (StorageMinecart cart, Player player){
		 //Check if the Player has typed the Collec create Command
		 
		 if (!playersCollectCreate.containsKey(player.getUniqueId())){
			 return false;
		 }else{
			 playersCollectCreate.remove(player.getUniqueId());
		 }
		 
		 if (!collectionMinecarts.containsKey(cart.getUniqueId())){
			 // register Minecart as a Cart added by a Player
			 collectionMinecarts.put(cart.getUniqueId(), 
					 new MinecartCollector(cart.getLocation().getWorld(), config.getCollectRate(), true));
			 player.sendMessage(ChatColor.YELLOW + plstr.getMinecartAddSucc());
			 
			 // repair cart
			 //cart.setDamage(0);
		 }else{
			player.sendMessage(ChatColor.RED + plstr.getMincartAlreadyAdded());
		 }
		 // Verursachter Damage auf 0 setzen
		 return true;
	 }
}
